/*
 * MenuList.java
 * main menu of the game
 *
 * (c) Arcanum
 * http://faqsite.narod.ru
 */

import javax.microedition.lcdui.*;
import java.io.*;

class MenuList extends List implements CommandListener {
// The images for the menu items
    static Image newImage;
    static Image contImage;
    static Image highImage;
    static Image setImage;
    static Image helpImage;
    static Image aboutImage;
    static Image exitImage;
    
// Command constants
    static final int CMD_NEW     = 0;
    static final String STR_NEW  = "New game";
    static final int CMD_CONT    = 1; 
    static final String STR_CONT = "Open saved";
    static final int CMD_SET     = 2; 
    static final String STR_SET = "Settings";
    static final int CMD_HELP    = 3; 
    static final String STR_HELP = "Help";    
    static final int CMD_ABOUT   = 4;
    static final String STR_ABOUT= "About";
    static final int CMD_EXIT    = 5;
    static final String STR_EXIT = "Exit";
// Text constants    
    static final String STR_HELP_TIT    = "Help";
    static final String STR_HELP_MSG    = "This board was designed for plaing two human players. The rules of renju game you can find at the web site of the Renju International Federation\nwww.renju.nu/rifrules.htm";
    static final String STR_ABOUT_TIT   = "About"; 
    static final String STR_ABOUT_MSG   = "Fighting stones\nThe classic renju\n(c) Arcanum\nfaqsite.narod.ru";
// Preload images
    static {
        try {
            newImage    = Image.createImage("res/new.png");
            contImage   = Image.createImage("res/opn.png");
            setImage    = Image.createImage("res/set.png");
            helpImage   = Image.createImage("res/hlp.png");
            aboutImage  = Image.createImage("res/abt.png");
            exitImage   = Image.createImage("res/ext.png");          
        }
        catch(IOException e) {
            System.out.println("Excpt:" + e);
        }
    }
    
    Display display;
    
// Forms and Canvas to be showed
    MainCanvas      mainCanvas;
    SetList         setList;
    
    public MenuList(String title) {
        super(title, List.IMPLICIT);
    
        display = Display.getDisplay(RenjuBoard.midlet);
    // Make list of menu items
        this.append(STR_NEW, newImage);
        this.append(STR_CONT, contImage);
        this.append(STR_SET, setImage);
        this.append(STR_HELP, helpImage);
        this.append(STR_ABOUT, aboutImage);
        this.append(STR_EXIT, exitImage);
        
        setCommandListener(this);
   }
    
    public void commandAction(Command cmd, Displayable dspl) {
        if(cmd == List.SELECT_COMMAND)
        {
            int i = getSelectedIndex();
            DataStore dataStore = new DataStore();
            
            switch(i)
            {
                case CMD_NEW:
                    SetData data  = dataStore.loadSettings();                    
                    if(mainCanvas == null)
                        mainCanvas = new MainCanvas(this, data.time, data.sound, data.light);
                    mainCanvas.start(data.time, data.sound, data.light);                    
                    display.setCurrent(mainCanvas);
                    break;
                case CMD_CONT:
                    data  = dataStore.loadSettings();                                        
                    if(mainCanvas == null)
                        mainCanvas = new MainCanvas(this, data.time, data.sound, data.light);
                    // load board
                    mainCanvas.resume();
                    display.setCurrent(mainCanvas);
                    break;
                case CMD_SET:
                    if(setList == null)
                        setList = new SetList(this);
                    display.setCurrent(setList); 
                    break;
                case CMD_ABOUT:
                    Alert aboutAlert = new Alert(
                        STR_ABOUT_TIT, STR_ABOUT_MSG, null, null);
                     aboutAlert.setTimeout(Alert.FOREVER);
                     display.setCurrent(aboutAlert, this);
                     break;               
                case CMD_HELP:
                    Alert helpAlert = new Alert(
                        STR_HELP_TIT, STR_HELP_MSG, null, null);
                     helpAlert.setTimeout(Alert.FOREVER);
                     display.setCurrent(helpAlert, this);
                     break;
                case CMD_EXIT:
                    RenjuBoard.exitMidlet(); break;
            }
        }
    }
    
}     
